=== debian/changelog ===
faiss (1.7.2-5) unstable; urgency=medium

  * Team upload.
  * Skip long-running MEAM_LEAK.* test during build

 -- Timo Röhling <roehling@debian.org>  Wed, 09 Feb 2022 08:00:49 +0100

faiss (1.7.2-4) unstable; urgency=medium

  * Team upload.
  * Fix implementation for 32 bit size_t
  * Enable unit tests unconditionally again
  * Fix floating point comparisons in unit tests

 -- Timo Röhling <roehling@debian.org>  Wed, 09 Feb 2022 01:38:46 +0100

faiss (1.7.2-3) unstable; urgency=medium

  * Team upload.
  * Fix CMake package export
  * Declare M-A: same for libfaiss-dev
  * Run full testsuite in autopkgtest
  * Fix dependencies

 -- Timo Röhling <roehling@debian.org>  Tue, 08 Feb 2022 12:23:14 +0100

faiss (1.7.2-2) unstable; urgency=medium

  * Team upload.
  * B-D on python3-dev
    - FAISS is built for the default Python version only (Closes: #998465)
  * Force inlining on simdlib helpers (Closes: #982100)

 -- Timo Röhling <roehling@debian.org>  Mon, 07 Feb 2022 08:17:20 +0100

faiss (1.7.2-1) unstable; urgency=medium

  * Team upload.

  [ Mo Zhou ]
  * New upstream version 1.7.2
  * Rebase existing patches.
  * Update buildflags for CMake.

  [ Timo Röhling ]
  * Fix SWIG FTBFS on 32 bit architectures
  * Bump Standards-Version to 4.6.0
  * Fix sections of binary packages
  * Fix package descriptions
  * Enable LFS
  * Use dh-sequence-* to run dh_python3 and dh_numpy3

 -- Timo Röhling <roehling@debian.org>  Sun, 06 Feb 2022 18:39:50 +0100
