=== c_api/CMakeLists.txt ===
--- 
+++ 
@@ -21,6 +21,7 @@
   IndexShards_c.cpp
   IndexReplicas_c.cpp
   Index_c.cpp
+  IndexBinary_c.cpp
   IndexScalarQuantizer_c.cpp
   MetaIndexes_c.cpp
   clone_index_c.cpp
