=== faiss/gpu/CMakeLists.txt ===
--- 
+++ 
@@ -24,6 +24,7 @@
   impl/BroadcastSum.cu
   impl/Distance.cu
   impl/FlatIndex.cu
+  impl/IndexUtils.cu
   impl/IVFAppend.cu
   impl/IVFBase.cu
   impl/IVFFlat.cu
@@ -102,6 +103,7 @@
   impl/FlatIndex.cuh
   impl/GeneralDistance.cuh
   impl/GpuScalarQuantizer.cuh
+  impl/IndexUtils.h
   impl/IVFAppend.cuh
   impl/IVFBase.cuh
   impl/IVFFlat.cuh
@@ -152,7 +154,7 @@
   utils/StaticUtils.h
   utils/Tensor-inl.cuh
   utils/Tensor.cuh
-  utils/ThrustAllocator.cuh
+  utils/ThrustUtils.cuh
   utils/Timer.h
   utils/Transpose.cuh
   utils/WarpPackedBits.cuh
