=== debian/changelog ===
faiss (1.7.3-2) unstable; urgency=medium

  * Team upload.
  * Fix autopkgtest
  * Disable tests for buggy cppcontrib implementations

 -- Timo Röhling <roehling@debian.org>  Thu, 17 Nov 2022 23:31:23 +0100

faiss (1.7.3-1) unstable; urgency=medium

  * Team upload.
  * New upstream version 1.7.3

 -- Timo Röhling <roehling@debian.org>  Thu, 10 Nov 2022 14:17:02 +0100

faiss (1.7.2-7) unstable; urgency=medium

  * Team upload.
  * Disable flaky MEM_LEAK.* tests in autopkgtest

 -- Timo Röhling <roehling@debian.org>  Fri, 05 Aug 2022 16:27:16 +0200

faiss (1.7.2-6) unstable; urgency=medium

  * Team upload.
  * Bump Standards-Version to 4.6.1
  * Drop unneeded build depend on libblis3-serial (Closes: #1012595)

 -- Timo Röhling <roehling@debian.org>  Fri, 10 Jun 2022 17:37:14 +0200
