=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: science
 Homepage: https://github.com/facebookresearch/faiss
 Priority: optional
-Standards-Version: 4.6.0
+Standards-Version: 4.6.1
 Vcs-Git: https://salsa.debian.org/deeplearning-team/faiss.git
 Vcs-Browser: https://salsa.debian.org/deeplearning-team/faiss
 Maintainer: Debian Deep Learning Team <debian-ai@lists.debian.org>
@@ -14,7 +14,6 @@
 	       dh-sequence-python3,
 	       dh-sequence-numpy3,
                libblas-dev,
-               libblis3-serial,
                libgtest-dev,
                liblapack-dev,
                python3-dev,
