=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -22,6 +22,9 @@
   test_mem_leak.cpp
   test_cppcontrib_sa_decode.cpp
   test_cppcontrib_uintreader.cpp
+  test_simdlib.cpp
+  test_approx_topk.cpp
+  test_RCQ_cropping.cpp
 )
 
 add_executable(faiss_test ${FAISS_TEST_SRC})
