=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: science
 Homepage: https://github.com/facebookresearch/faiss
 Priority: optional
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Vcs-Git: https://salsa.debian.org/deeplearning-team/faiss.git
 Vcs-Browser: https://salsa.debian.org/deeplearning-team/faiss
 Maintainer: Debian Deep Learning Team <debian-ai@lists.debian.org>
@@ -16,7 +16,8 @@
                libblas-dev,
                libgtest-dev,
                liblapack-dev,
-               python3-dev,
+	       libpython3-dev,
+               python3-dev:any,
                python3-numpy,
                python3-setuptools,
                swig
